// simple.frag

#extension GL_EXT_gpu_shader4 : enable

// fragment shader of phong shader

#define USE_REFLECTION (1)  /* XyL[vZɔ˃xNggp */

uniform int lightNumberPhong;
varying vec3 position;
varying vec3 normal;

void main (void)
{
    vec4 factor = vec4(1.0, 1.0, 1.0, 0.0); // alpha1𒴂Ȃ悤
    vec3 fnormal = normalize(normal);
    gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
    
    float alpha = gl_FrontLightProduct[0].ambient[3];

    for (int i = 0; i < lightNumberPhong; i++){
	vec3 lightVec = gl_LightSource[i].position.xyz - position * gl_LightSource[i].position[3];
	
	// ܂ł̋ 
	//float dis = length(lightVec);
	
	lightVec = normalize(lightVec);
	
	// W 
	/*
	  float attenuation = 1.0 / (gl_LightSource[0].constantAttenuation +
	  gl_LightSource[0].linearAttenuation * dis +
	  gl_LightSource[0].quadraticAttenuation * dis * dis);
	*/
	//float attenuation = 1.0;
	
	// fBt[Y 
	float diffuse = dot(lightVec, fnormal);
	
	// ArGg 
	gl_FragColor += gl_FrontLightProduct[i].ambient;
	
	if (diffuse > 0.0){
#if USE_REFLECTION
	    //˃xNg 
	    vec3 viewVec = normalize(-position);
	    vec3 reflectVec = reflect(-lightVec, fnormal);
	    float specular = pow(max(dot(viewVec, reflectVec), 0.0),
				 gl_FrontMaterial.shininess);
#else
	    // n[txNg 
	    vec3 viewVec = normalize(-position);
	    vec3 halfVec = normalize(lightVec + viewVec);
	    float specular = pow(max(dot(fnormal, halfVec), 0.0), 
				 gl_FrontMaterial.shininess);
#endif
	    gl_FragColor += 
		gl_FrontLightProduct[i].diffuse * diffuse * factor
		+ gl_FrontLightProduct[i].specular * specular * factor;
	}
    }

    gl_FragColor[3] = alpha;
}
